# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
require 'puppet_x/enterprisemodules/postgres/access'

module Puppet_X
  module EnterpriseModules
    module Postgres
      # Docs
      module TitleParser
        include Puppet_X::EnterpriseModules::Postgres::Access

        def map_title_to_db(*attributes, &proc)
          map_title_to_db_internal(*(attributes << :db), &proc)
        end

        # @private
        def map_title_to_db_internal(*attributes, &proc)
          db_parameter = attributes.pop
          base_regexp = proc ? yield : /(.+)/
          without_db_regexp = Regexp.new("^(#{base_regexp.source})$")
          with_db_regexp    = Regexp.new("^(#{base_regexp.source}@(.*))$")
          map_titles_to_attributes([
                                     with_db_regexp, [:name] + attributes + [db_parameter],
                                     without_db_regexp, [:name] + attributes
                                   ])
        end
      end
    end
  end
end
